diff --git a/hubs/tests/views/test_widget.py b/hubs/tests/views/test_widget.py
new file mode 100644
index 0000000..7a8d2f7
--- /dev/null
+++ b/hubs/tests/views/test_widget.py
@@ -0,0 +1,23 @@
+from __future__ import unicode_literals
+
+
+from hubs.app import app
+from hubs.tests import APPTest, auth_set
+
+
+class WidgetTestCase(APPTest):
+
+    def test_source_name(self):
+        with auth_set(app, None):
+            url = '/source/about'
+            result = self.app.get(url)
+            self.assertEqual(result.status_code, 302)
+            expected_str = 'https://pagure.io/fedora-hubs/' \
+                           'blob/develop/f/hubs/widgets/about/__init__.py'
+            self.assertIn(expected_str, result.get_data(as_text=True))
+
+    def test_source_name_not_existent(self):
+        with auth_set(app, None):
+            url = '/source/notexistent'
+            result = self.app.get(url)
+            self.assertEqual(result.status_code, 404)
diff --git a/hubs/tests/widgets/__init__.py b/hubs/tests/widgets/__init__.py
new file mode 100644
index 0000000..7d171e4
--- /dev/null
+++ b/hubs/tests/widgets/__init__.py
@@ -0,0 +1,47 @@
+from __future__ import unicode_literals
+
+import json
+import unittest
+
+import hubs.models
+from hubs.tests import APPTest, FakeAuthorization
+
+
+class WidgetTest(APPTest):
+
+    plugin = None  # The name in hubs.widgets.registry
+
+    def populate(self):
+        super(WidgetTest, self).populate()
+        hub = hubs.models.Hub.by_name('ralph')
+        widget = hubs.models.Widget(
+            plugin='library',
+            index=51,
+            # We must add a url in the config or it'll crash.
+            _config=json.dumps({"urls": "ralph/"})
+        )
+        hub.widgets.append(widget)
+        self.session.commit()
+
+    def _test_view_authz(self):
+        # Test authorizations on the root view.
+        if not self.plugin:
+            raise unittest.SkipTest
+        hub = hubs.models.Hub.query.get("ralph")
+        widget = self.widget_instance(hub.name, self.plugin)
+        url = '/%s/w/%s/%i/' % (hub.name, self.plugin, widget.idx)
+        # Public
+        self.check_url(url, None, 200)
+        # Preview
+        hub.config.visibility = "preview"
+        widget.visibility = "restricted"
+        self.session.commit()
+        self.check_url(url, None, 403)  # anonymous
+        self.check_url(url, FakeAuthorization('decause'), 200)  # logged-in
+        # Private
+        widget.hub.config.visibility = "private"
+        self.session.commit()
+        self.check_url(url, None, 403)  # anonymous
+        self.check_url(url, FakeAuthorization('decause'), 403)  # logged-in
+        hub.subscribe(hubs.models.User.query.get("decause"), "member")
+        self.check_url(url, FakeAuthorization('decause'), 200)  # member
diff --git a/hubs/tests/widgets/test_about.py b/hubs/tests/widgets/test_about.py
new file mode 100644
index 0000000..dd00e20
--- /dev/null
+++ b/hubs/tests/widgets/test_about.py
@@ -0,0 +1,24 @@
+from __future__ import unicode_literals
+
+import json
+
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
+
+
+class TestAbout(WidgetTest):
+    plugin = 'about'  # The name in hubs.widgets.registry
+
+    def test_data_simple(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        user = FakeAuthorization('ralph')
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data['data'], {
+            'text': 'Testing.',
+            'title': "<span class='glyphicon glyphicon-info-sign' "
+                     "aria-hidden='true'></span> About",
+        })
+
+    def test_view_authz(self):
+        self._test_view_authz()
diff --git a/hubs/tests/widgets/test_badges.py b/hubs/tests/widgets/test_badges.py
new file mode 100644
index 0000000..3cd2ee2
--- /dev/null
+++ b/hubs/tests/widgets/test_badges.py
@@ -0,0 +1,61 @@
+from __future__ import unicode_literals
+
+import json
+
+import hubs.widgets
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
+
+
+class TestBadges(WidgetTest):
+    plugin = 'badges'  # The name in hubs.widgets.registry
+
+    def test_data_simple(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        user = FakeAuthorization('ralph')
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEquals(data['plugin'], 'badges')
+        self.assertIn('assertions', data['data'].keys())
+
+    def test_should_invalidate_wrong_topic(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        # msg = self.get_fedmsg('2016-ebb84660-59e9-4e68-af8f-4e6f49348b88')
+        msg = {'topic': 'hubs.widget.update.WRONG.TOPIC'}
+        module = hubs.widgets.registry[widget.plugin]
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
+        self.assertFalse(result)
+
+    def test_should_invalidate_wrong_user(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        # msg = self.get_fedmsg('2016-e371c7f6-bc8e-4632-8e33-b9102dc30b5f')
+        msg = {'topic': 'fedbadges.badge.award',
+               'msg': {'user': {'username': 'not_ralph'}}}
+        module = hubs.widgets.registry[widget.plugin]
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
+        self.assertFalse(result)
+
+    def test_should_invalidate_good_match_fedbadges(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        # msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
+        msg = {'topic': 'fedbadges.badge.award',
+               'msg': {'user': {'username': 'ralph'}}}
+        module = hubs.widgets.registry[widget.plugin]
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
+        self.assertTrue(result)
+
+    def test_should_invalidate_good_match_hubswidget(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        # msg = self.get_fedmsg('2016-1fbb1135-681b-4d3b-9a40-d0f6ebd313f4')
+        msg = {'topic': 'hubs.widget.update',
+               'msg': {'widget': {'id': widget.idx + 1}}}
+        module = hubs.widgets.registry[widget.plugin]
+        func = module.get_cached_functions()['GetBadges']
+        result = func(widget).should_invalidate(msg)
+        self.assertTrue(result)
+
+    def test_view_authz(self):
+        self._test_view_authz()
diff --git a/hubs/tests/widgets/test_contact.py b/hubs/tests/widgets/test_contact.py
new file mode 100644
index 0000000..3d885d1
--- /dev/null
+++ b/hubs/tests/widgets/test_contact.py
@@ -0,0 +1,178 @@
+from __future__ import unicode_literals
+
+import json
+
+import flask
+import mock
+
+import hubs
+from hubs.models import Hub, Widget
+from hubs.tests import FakeAuthorization, auth_set
+from . import WidgetTest
+
+
+def mocked_requests_get(*args, **kwargs):
+    class MockResponse:  # flake8: noqa
+        def __init__(self, json_data, status_code):
+            self.json_data = json_data
+            self.status_code = status_code
+            self.text = str(json_data)
+        def json(self):
+            return self.json_data
+
+    if '/decause' in args[0]:
+        data = {
+            "current": 0,
+            "decrements": 0,
+            "increments": 0,
+            "release": "f24",
+            "total": 0,
+            "username": "decause"
+        }
+        return MockResponse(json_data=data, status_code=200)
+
+    return MockResponse({}, 404)
+
+def mocked_requests_post(*args, **kwargs):
+    class MockResponse:
+        def __init__(self, json_data, status_code):
+            self.json_data = json_data
+            self.status_code = status_code
+            self.text = str(json_data)
+
+        def json(self):
+            return self.json_data
+    if '/decause' in kwargs['url']:
+        data = {
+            "current": 1,
+            "decrements": 0,
+            "increments": 1,
+            "release": "f24",
+            "total": 1,
+            "username": "decause"
+        }
+        return MockResponse(json_data=data, status_code=200)
+
+    return MockResponse({}, 404)
+
+
+class ContactsTest(WidgetTest):
+
+    plugin = "contact"
+
+    def setUp(self):
+        super(ContactsTest, self).setUp()
+        hub = Hub.by_name('ralph')
+        widget = Widget(
+            plugin='contact',
+            index=1,
+        )
+        hub.widgets.append(widget)
+        self.session.commit()
+        self.widget_idx = widget.idx
+
+    def test_data_simple(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        user = FakeAuthorization('ralph')
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data['data'], {
+            'account_age': 'Oct 2010',
+            'email': 'ralph@fedoraproject.org',
+            'ircnick': 'ralph',
+            'karma_url': '/ralph/w/contact/%i/plus-plus/ralph/status'
+                         % widget.idx,
+            'location': 'United States',
+            'timezone': 'UTC',
+            'usergroup': True,
+        })
+
+    def test_view_authz(self):
+        self._test_view_authz()
+
+    @mock.patch('requests.get', side_effect=mocked_requests_get)
+    def test_plus_plus_get_valid(self, mock_get):
+        widget = self.widget_instance("ralph", self.plugin)
+        url = "/ralph/w/contact/%d/plus-plus/%s/status" % (
+            self.widget_idx, "decause")
+        result = self.app.get(url)
+        expected = {
+            "current": 0,
+            "decrements": 0,
+            "increments": 0,
+            "release": "f24",
+            "total": 0,
+            "username": "decause"
+        }
+        self.assertEqual(result.status_code, 200)
+        self.assertEqual(
+            json.loads(result.get_data(as_text=True)),
+            expected)
+
+    @mock.patch('requests.post', side_effect=mocked_requests_post)
+    def test_plus_plus_post_increment_valid(self, mock_post):
+        widget = self.widget_instance("ralph", self.plugin)
+        url = "/ralph/w/contact/%d/plus-plus/%s/update" % (
+            self.widget_idx, "decause")
+        user = FakeAuthorization('ralph')
+        with auth_set(hubs.app.app, user):
+            result = self.app.post(url, data={'increment': True})
+            expected = {
+                "current": 1,
+                "decrements": 0,
+                "increments": 1,
+                "release": "f24",
+                "total": 1,
+                "username": "decause"
+            }
+            self.assertEqual(result.status_code, 200)
+            self.assertEqual(
+                json.loads(result.get_data(as_text=True)),
+                expected)
+
+    @mock.patch('requests.post', side_effect=mocked_requests_post)
+    def test_plus_plus_post_increment_myself_error(self, mock_post):
+        widget = self.widget_instance("ralph", self.plugin)
+        url = "/ralph/w/contact/%d/plus-plus/%s/update" % (
+            self.widget_idx, "ralph")
+        user = FakeAuthorization('ralph')
+        with auth_set(hubs.app.app, user):
+            result = self.app.post(url, data={'increment': True})
+            self.assertEqual(result.status_code, 403)
+            self.assertEqual(
+                result.get_data(as_text=True),
+                'You may not modify your own karma.')
+
+    @mock.patch('requests.post', side_effect=mocked_requests_post)
+    def test_plus_plus_post_increment_user_does_not_exist(self, mock_post):
+        widget = self.widget_instance("ralph", self.plugin)
+        url = "/ralph/w/contact/%d/plus-plus/%s/update" % (
+            self.widget_idx, "doesnotexist")
+        user = FakeAuthorization('ralph')
+        with auth_set(hubs.app.app, user):
+            result = self.app.post(url, data={'increment': True})
+            self.assertEqual(result.status_code, 404)
+            self.assertEqual(
+                result.get_data(as_text=True),
+                'User does not exist')
+
+    @mock.patch('requests.post', side_effect=mocked_requests_post)
+    def test_plus_plus_post_increment_no_data_error(self, mock_post):
+        widget = self.widget_instance("ralph", self.plugin)
+        url = "/ralph/w/contact/%d/plus-plus/%s/update" % (
+            self.widget_idx, "decause")
+        user = FakeAuthorization('ralph')
+        with auth_set(hubs.app.app, user):
+            result = self.app.post(url, data={})
+            self.assertEqual(result.status_code, 400)
+            exp_str = "You must set 'decrement' or 'increment' " \
+                      "with a boolean value in the body"
+            self.assertEqual(result.get_data(as_text=True), exp_str)
+
+    def test_plus_plus_receiver_does_not_exist(self):
+        widget = self.widget_instance("ralph", self.plugin)
+        url = "/ralph/w/contact/%d/plus-plus/%s/status" % (
+            self.widget_idx, "doesnotexist")
+        result = self.app.get(url)
+        self.assertEqual(result.status_code, 404)
+        self.assertEqual(result.get_data(as_text=True), 'User does not exist')
diff --git a/hubs/tests/widgets/test_fedmsgstats.py b/hubs/tests/widgets/test_fedmsgstats.py
new file mode 100644
index 0000000..87b5ae0
--- /dev/null
+++ b/hubs/tests/widgets/test_fedmsgstats.py
@@ -0,0 +1,30 @@
+from __future__ import unicode_literals
+
+import json
+
+from hubs.tests import FakeAuthorization
+from . import WidgetTest
+
+
+class TestFedmsgStats(WidgetTest):
+    plugin = 'fedmsgstats'  # The name in hubs.widgets.registry
+
+    def test_data_simple(self):
+        widget = self.widget_instance('ralph', self.plugin)
+        user = FakeAuthorization('ralph')
+        response = self.check_url('/ralph/%i/json' % widget.idx, user)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data['data'], {
+            u'fedmsgs': 83854,
+            u'fedmsgs_text': u'83,854',
+            u'subscribers': [],
+            u'subscribed_to': [],
+            u'subscribers_text': u'0',
+            u'subscribed_text': u'0',
+            u'username': u'ralph',
+            u'hub_subscribe_url': u'/api/hub/ralph/subscribe',
+            u'hub_unsubscribe_url': u'/api/hub/ralph/unsubscribe',
+        })
+
+    def test_view_authz(self):
+        self._test_view_authz()
